---
product: "AG Charts"
title: "Axis Labels"
description: "Use JavaScript chart axis labels to provide clear identification and context for the data represented on each axis in a JavaScript chart or JavaScript graph."
framework: javascript
version: "14.2.0"
related:
    - title: "Axis Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-configuration/"
    - title: "Axis Types"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-types/"
    - title: "Axis Intervals"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-intervals/"
    - title: "Axis Domain"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-domain/"
    - title: "Axis Position"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-position/"
    - title: "Time Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/"
    - title: "Grid Lines & Band Shading"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-grid-lines/"
    - title: "Secondary Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-secondary/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Axis Labels

Axis labels provide clear identification and context for the data represented on each axis in a chart.

## Collision Avoidance

AG Charts has a number of methods to avoid axis label collisions, which occur when two labels overlap or when a label exceeds the axis's `maxThicknessRatio`.

#### Axis Label Collision

```ts
import {
  AgBarSeriesOptions,
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  AgCharts,
  AgNumberAxisOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  TextWrap,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "year",
      yKey: "value",
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {},
    },
    y: {
      type: "number",
      label: {},
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function reset() {
  const categoryAxis = options.axes!.x! as AgCategoryAxisOptions;
  const numberAxis = options.axes!.y! as AgNumberAxisOptions;
  delete categoryAxis.label!.rotation;
  delete categoryAxis.label!.autoRotate;
  delete categoryAxis.label!.avoidCollisions;
  delete categoryAxis.label!.truncate;
  delete numberAxis.label!.rotation;
  delete numberAxis.label!.autoRotate;
  delete numberAxis.label!.avoidCollisions;
  delete numberAxis.label!.truncate;
  (options.series![0] as AgBarSeriesOptions).xKey = "year";

  chart.update(options);
}

function rotationChange(e: Event) {
  const categoryAxis = options.axes!.x! as AgCategoryAxisOptions;
  const numberAxis = options.axes!.y! as AgNumberAxisOptions;
  delete categoryAxis.label!.rotation;
  delete numberAxis.label!.rotation;
  const value = (e.target as HTMLInputElement).value;
  switch (value) {
    case "auto":
      categoryAxis.label!.autoRotate = true;
      numberAxis.label!.autoRotate = true;
      break;
    case "fixed":
      categoryAxis.label!.rotation = 45;
      numberAxis.label!.rotation = 45;
      categoryAxis.label!.autoRotate = false;
      numberAxis.label!.autoRotate = false;
      break;
    case "disabled":
      categoryAxis.label!.autoRotate = false;
      numberAxis.label!.autoRotate = false;
      break;
  }

  chart.update(options);
}

function labelChange(e: Event) {
  const value = (e.target as HTMLInputElement).value;
  (options.series![0] as AgBarSeriesOptions).xKey = value;

  chart.update(options);
}

function truncationChange(e: Event) {
  const categoryAxis = options.axes!.x! as AgCategoryAxisOptions;
  const numberAxis = options.axes!.y! as AgNumberAxisOptions;
  delete categoryAxis.label!.rotation;
  delete numberAxis.label!.rotation;
  const value = (e.target as HTMLInputElement).value;
  const enabled = value === "enabled";
  categoryAxis.label!.truncate = enabled;
  numberAxis.label!.truncate = enabled;

  chart.update(options);
}

function avoidanceChange(e: Event) {
  const categoryAxis = options.axes!.x! as AgCategoryAxisOptions;
  const numberAxis = options.axes!.y! as AgNumberAxisOptions;
  delete categoryAxis.label!.rotation;
  delete numberAxis.label!.rotation;
  const value = (e.target as HTMLInputElement).value;
  const enabled = value === "enabled";
  categoryAxis.label!.avoidCollisions = enabled;
  numberAxis.label!.avoidCollisions = enabled;

  chart.update(options);
}

function wrapChange(e: Event) {
  const categoryAxis = options.axes!.x! as AgCategoryAxisOptions;
  const numberAxis = options.axes!.y! as AgNumberAxisOptions;
  const value = (e.target as HTMLInputElement).value as TextWrap;
  categoryAxis.label!.wrapping = value;
  numberAxis.label!.wrapping = value;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).reset = reset;
  (<any>window).rotationChange = rotationChange;
  (<any>window).labelChange = labelChange;
  (<any>window).truncationChange = truncationChange;
  (<any>window).avoidanceChange = avoidanceChange;
  (<any>window).wrapChange = wrapChange;
}
```

[Live example: Axis Label Collision](https://www.ag-grid.com/charts/archive/14.2.0/typescript/axes-labels/examples/axis-label-collision/)

In this example:

- Use the grab handle in the bottom right of the example to resize the chart. Observe how the labels behave with the different options applied.
- The first dropdown allows enabling and disabling collision avoidance altogether.
- The second dropdown buttons allows changing the length of the labels. This more easily shows the [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#wrapping) and [skipping](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#skipping) behaviour.
- The [Rotation](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#rotation), [Wrapping](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#wrapping) and [Truncation](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#truncation) controls enable exploration of their behaviour with all the available options.
- If enabled, labels try [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#wrapping), then [truncation](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#truncation), [rotation](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#rotation), and finally [skipping](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#skipping) if needed.

Collision avoidance is enabled by default, to disable set `label.avoidCollisions` to false.

```js
{
    label: {
        avoidCollisions: false,
    },
}
```

### Wrapping

Text wrapping allows labels to fit within constrained space by breaking across multiple lines.

Wrapping behaviour is set with the `label.wrapping` property:

- `'on-space'` - Wraps only on whitespace. If no suitable space is found, the next avoidance strategy is used.
- `'always'` - Forces wrapping to fit within the available space, including breaking words if needed.
- `'hyphenate'` - Similar to `'always'`, but inserts a hyphen (`-`) when wrapping in the middle of a word.
- `'never'` - Disables wrapping. Labels will remain on a single line, with the next avoidance strategy being used.

```js
{
    label: {
        wrapping: 'hyphenate',
    },
}
```

This defaults to `on-space` for Category Axes, and to `never` on all other axes types.

### Truncation

Set `truncate: true` on a label to truncate the label’s text when there isn't enough space to display it fully. This ensures as much as possible of each label remains readable without reducing the number of ticks.

When truncation occurs, hovering over the truncated text will display a tooltip with the full label text.

> **Note**
>
> Truncation takes precedence over auto-rotation. When truncation is enabled, auto-rotation will not apply.

### Rotation

Rotating axis labels allows fitting more labels into a smaller area, at the expense of readability.

Three rotation options are available:

- No rotation.
- Fixed rotation - labels are always rotated by the amount specified in the `rotation` property.
- Automatic rotation - labels are rotated if any label will be wider than the gap between ticks.

Automatic rotation can be enabled or disabled using the `autoRotate` property. It is also possible to specify a rotation angle for the automatic rotation via the `autoRotateAngle` property.

Category axes have `autoRotate` enabled by default with a default `autoRotateAngle` of `335`.

### Skipping

Label skipping is performed automatically when there is a high likelihood of collisions between labels. Labels that would collide are not displayed.

A collision is defined as labels coming within 10 pixels of each other. This minimum gap allowed between the axis labels before skipping can be configured using the `label.minSpacing` property.

```js
{
    label: {
        minSpacing: 20,
    },
}
```

If `autoRotate` is enabled, rotation will be attempted before label skipping applies.

## Alignment

Axis labels are aligned within the axis thickness and bands, with a default alignment derived from the axis position and label rotation. Both directions can be set explicitly.

### Text Alignment

Use `label.textAlign` to control the horizontal alignment of labels. This is most useful on a vertical axis containing labels of differing width.

#### Axis Label Text Alignment

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AgNumberAxisOptions,
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

type TextAlign = "left" | "center" | "right";

const initialXTextAlign: TextAlign = "center";
// 'left' is what a right-positioned vertical axis derives, so the labels start unchanged.
const initialYTextAlign: TextAlign = "left";
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "quarter",
      yKey: "revenue",
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        textAlign: initialXTextAlign,
      },
    },
    y: {
      type: "number",
      position: "right",
      label: {
        textAlign: initialYTextAlign,
        formatter: ({ value }) => `$${value.toLocaleString()}`,
      },
    } as AgNumberAxisOptions,
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setXTextAlign(event: Event) {
  options.axes!.x!.label!.textAlign = (event.target as HTMLInputElement)
    .value as TextAlign;

  chart.update(options);
}

function setYTextAlign(event: Event) {
  options.axes!.y!.label!.textAlign = (event.target as HTMLInputElement)
    .value as TextAlign;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setXTextAlign = setXTextAlign;
  (<any>window).setYTextAlign = setYTextAlign;
}
```

[Live example: Axis Label Text Alignment](https://www.ag-grid.com/charts/archive/14.2.0/typescript/axes-labels/examples/axis-label-text-align/)

```js
{
    axes: {
        x: {
            label: {
                textAlign: 'center',
            },
        },
        y: {
            label: {
                textAlign: 'left',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `textAlign` options for each axis.
- On the vertical number axis, labels are horizontally aligned within the axis thickness.
- On the horizontal category axis, labels are horizontally aligned within each category band.

### Vertical Alignment

Use `label.verticalAlign` to control the vertical alignment of labels. This is most useful on a horizontal axis containing labels of differing height.

#### Axis Label Vertical Alignment

```ts
import {
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

type VerticalAlign = "top" | "middle" | "bottom";

// The alignment each axis derives from its position, so the labels start unchanged.
const initialXVerticalAlign: VerticalAlign = "top";
const initialYVerticalAlign: VerticalAlign = "middle";
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "region",
      yKey: "revenue",
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        // Region names wrap onto a differing number of lines, so alignment matters here.
        wrapping: "always",
        verticalAlign: initialXVerticalAlign,
      },
    } as AgCategoryAxisOptions,
    y: {
      type: "number",
      label: {
        verticalAlign: initialYVerticalAlign,
        formatter: ({ value }) => `$${value.toLocaleString()}`,
      },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setXVerticalAlign(event: Event) {
  options.axes!.x!.label!.verticalAlign = (event.target as HTMLInputElement)
    .value as VerticalAlign;

  chart.update(options);
}

function setYVerticalAlign(event: Event) {
  options.axes!.y!.label!.verticalAlign = (event.target as HTMLInputElement)
    .value as VerticalAlign;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setXVerticalAlign = setXVerticalAlign;
  (<any>window).setYVerticalAlign = setYVerticalAlign;
}
```

[Live example: Axis Label Vertical Alignment](https://www.ag-grid.com/charts/archive/14.2.0/typescript/axes-labels/examples/axis-label-vertical-align/)

```js
{
    axes: {
        x: {
            label: {
                verticalAlign: 'top',
            },
        },
        y: {
            label: {
                verticalAlign: 'middle',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `verticalAlign` options for each axis.
- On the horizontal category axis, labels are vertically aligned within the axis thickness.
- On the vertical number axis, labels are vertically aligned around the tick they label.

## Label Text Formatting

The label text is taken directly from the data.

To format how this is displayed, either use a [Global Formatter](https://www.ag-grid.com/charts/archive/14.2.0/javascript/formatters/), or specify an axis label level [Formatter](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#formatter) or [Format](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-labels/#format) as explained below.

> **Note**
>
> This section discusses formatting the label text. See the [Axis Intervals](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-intervals/) section to learn how to configure which labels are shown.

### Formatter

The `label.formatter` callback allows maximum flexibility for controlling what appears in the labels.

#### Axis Label Formatter

```ts
import {
  AgChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgChartOptions<DataType> = {
  data: getData(),
  title: {
    text: "Desktop Operating Systems",
  },
  series: [
    {
      type: "bar",
      xKey: "os",
      yKey: "share",
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        formatter: ({ value }) =>
          value === "Windows" ? "== Windows ==" : value,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: ({ value }) => `${value * 100}%`,
      },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Axis Label Formatter](https://www.ag-grid.com/charts/archive/14.2.0/typescript/axes-labels/examples/axis-label-formatter/)

```js
{
    label: {
        formatter: function (params) {
            return params.value * 100 + '%';
        },
    },
}
```

In the above example:

- The number axis uses a formatter to multiply by 100 and append `'%'` to all values.
- The category axis uses a formatter to add `'=='` around the 'Windows' label only.

The formatter function receives a single `params` object which contains:

- The raw `value` of the label (without any default formatting applied).
- The `index` of the label in the data array.
- The number of `fractionDigits`, if the value is a number.

It is called for each label and should return a string.

### Format

The `label.format` property takes a static string representing a time or number format. This has less flexibility than the formatter, but can be serialised. For all time axes, an object format mapping a unit of time to a format string can also be used.

#### Label Format

```ts
import {
  AgChartOptions,
  AgCharts,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
]);

const options: AgChartOptions = {
  series: [
    {
      type: "line",
      xKey: "date",
      yKey: "temp",
    },
  ],
  axes: {
    x: {
      type: "unit-time",
      interval: { step: "month" },
      label: {
        format: "%b %Y",
      },
    },
    y: {
      type: "number",
      label: {
        format: "$#{0>6.2f}",
      },
    },
  },
  data: [
    { date: new Date("2019-01-01"), temp: 82.0 },
    { date: new Date("2019-02-01"), temp: 75.0 },
    { date: new Date("2019-03-01"), temp: 62.0 },
    { date: new Date("2019-04-01"), temp: 99.0 },
    { date: new Date("2019-05-01"), temp: 82.0 },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Label Format](https://www.ag-grid.com/charts/archive/14.2.0/typescript/axes-labels/examples/axis-label-format/)

```js
{
    label: {
        format: '%b %Y',
    },
}
```

```js
{
    label: {
        format: '$#{0>6.2f}',
    },
}
```

In the above example:

- The time axis uses a format to display the short month name and full year for all values.
- The number axis uses a format to prepend a `'$'` and use 2 decimal places for all values. Shorter numbers are padding with `'0'`.

The syntax used in the format strings depends on the axis type.

See the [Formatters](https://www.ag-grid.com/charts/archive/14.2.0/javascript/formatters/#format-strings) page for a full list of the available formats.

## Customisation

See [Fills & Borders](https://www.ag-grid.com/charts/archive/14.2.0/javascript/fills-borders/) for details on customising axis labels.


---
product: "AG Charts"
title: "Axis Labels"
description: "Use Angular chart axis labels to provide clear identification and context for the data represented on each axis in a Angular chart or Angular graph."
framework: angular
version: "14.2.0"
related:
    - title: "Axis Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-configuration/"
    - title: "Axis Types"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-types/"
    - title: "Axis Intervals"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-intervals/"
    - title: "Axis Domain"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-domain/"
    - title: "Axis Position"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-position/"
    - title: "Time Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/"
    - title: "Grid Lines & Band Shading"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-grid-lines/"
    - title: "Secondary Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-secondary/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Axis Labels

Axis labels provide clear identification and context for the data represented on each axis in a chart.

## Collision Avoidance

AG Charts has a number of methods to avoid axis label collisions, which occur when two labels overlap or when a label exceeds the axis's `maxThicknessRatio`.

#### Axis Label Collision

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Axis Label Collision](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/examples/axis-label-collision/)

In this example:

- Use the grab handle in the bottom right of the example to resize the chart. Observe how the labels behave with the different options applied.
- The first dropdown allows enabling and disabling collision avoidance altogether.
- The second dropdown buttons allows changing the length of the labels. This more easily shows the [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#wrapping) and [skipping](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#skipping) behaviour.
- The [Rotation](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#rotation), [Wrapping](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#wrapping) and [Truncation](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#truncation) controls enable exploration of their behaviour with all the available options.
- If enabled, labels try [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#wrapping), then [truncation](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#truncation), [rotation](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#rotation), and finally [skipping](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#skipping) if needed.

Collision avoidance is enabled by default, to disable set `label.avoidCollisions` to false.

```js
{
    label: {
        avoidCollisions: false,
    },
}
```

### Wrapping

Text wrapping allows labels to fit within constrained space by breaking across multiple lines.

Wrapping behaviour is set with the `label.wrapping` property:

- `'on-space'` - Wraps only on whitespace. If no suitable space is found, the next avoidance strategy is used.
- `'always'` - Forces wrapping to fit within the available space, including breaking words if needed.
- `'hyphenate'` - Similar to `'always'`, but inserts a hyphen (`-`) when wrapping in the middle of a word.
- `'never'` - Disables wrapping. Labels will remain on a single line, with the next avoidance strategy being used.

```js
{
    label: {
        wrapping: 'hyphenate',
    },
}
```

This defaults to `on-space` for Category Axes, and to `never` on all other axes types.

### Truncation

Set `truncate: true` on a label to truncate the label’s text when there isn't enough space to display it fully. This ensures as much as possible of each label remains readable without reducing the number of ticks.

When truncation occurs, hovering over the truncated text will display a tooltip with the full label text.

> **Note**
>
> Truncation takes precedence over auto-rotation. When truncation is enabled, auto-rotation will not apply.

### Rotation

Rotating axis labels allows fitting more labels into a smaller area, at the expense of readability.

Three rotation options are available:

- No rotation.
- Fixed rotation - labels are always rotated by the amount specified in the `rotation` property.
- Automatic rotation - labels are rotated if any label will be wider than the gap between ticks.

Automatic rotation can be enabled or disabled using the `autoRotate` property. It is also possible to specify a rotation angle for the automatic rotation via the `autoRotateAngle` property.

Category axes have `autoRotate` enabled by default with a default `autoRotateAngle` of `335`.

### Skipping

Label skipping is performed automatically when there is a high likelihood of collisions between labels. Labels that would collide are not displayed.

A collision is defined as labels coming within 10 pixels of each other. This minimum gap allowed between the axis labels before skipping can be configured using the `label.minSpacing` property.

```js
{
    label: {
        minSpacing: 20,
    },
}
```

If `autoRotate` is enabled, rotation will be attempted before label skipping applies.

## Alignment

Axis labels are aligned within the axis thickness and bands, with a default alignment derived from the axis position and label rotation. Both directions can be set explicitly.

### Text Alignment

Use `label.textAlign` to control the horizontal alignment of labels. This is most useful on a vertical axis containing labels of differing width.

#### Axis Label Text Alignment

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Axis Label Text Alignment](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/examples/axis-label-text-align/)

```js
{
    axes: {
        x: {
            label: {
                textAlign: 'center',
            },
        },
        y: {
            label: {
                textAlign: 'left',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `textAlign` options for each axis.
- On the vertical number axis, labels are horizontally aligned within the axis thickness.
- On the horizontal category axis, labels are horizontally aligned within each category band.

### Vertical Alignment

Use `label.verticalAlign` to control the vertical alignment of labels. This is most useful on a horizontal axis containing labels of differing height.

#### Axis Label Vertical Alignment

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Axis Label Vertical Alignment](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/examples/axis-label-vertical-align/)

```js
{
    axes: {
        x: {
            label: {
                verticalAlign: 'top',
            },
        },
        y: {
            label: {
                verticalAlign: 'middle',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `verticalAlign` options for each axis.
- On the horizontal category axis, labels are vertically aligned within the axis thickness.
- On the vertical number axis, labels are vertically aligned around the tick they label.

## Label Text Formatting

The label text is taken directly from the data.

To format how this is displayed, either use a [Global Formatter](https://www.ag-grid.com/charts/archive/14.2.0/angular/formatters/), or specify an axis label level [Formatter](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#formatter) or [Format](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/#format) as explained below.

> **Note**
>
> This section discusses formatting the label text. See the [Axis Intervals](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-intervals/) section to learn how to configure which labels are shown.

### Formatter

The `label.formatter` callback allows maximum flexibility for controlling what appears in the labels.

#### Axis Label Formatter

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Axis Label Formatter](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/examples/axis-label-formatter/)

```js
{
    label: {
        formatter: function (params) {
            return params.value * 100 + '%';
        },
    },
}
```

In the above example:

- The number axis uses a formatter to multiply by 100 and append `'%'` to all values.
- The category axis uses a formatter to add `'=='` around the 'Windows' label only.

The formatter function receives a single `params` object which contains:

- The raw `value` of the label (without any default formatting applied).
- The `index` of the label in the data array.
- The number of `fractionDigits`, if the value is a number.

It is called for each label and should return a string.

### Format

The `label.format` property takes a static string representing a time or number format. This has less flexibility than the formatter, but can be serialised. For all time axes, an object format mapping a unit of time to a format string can also be used.

#### Label Format

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Label Format](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-labels/examples/axis-label-format/)

```js
{
    label: {
        format: '%b %Y',
    },
}
```

```js
{
    label: {
        format: '$#{0>6.2f}',
    },
}
```

In the above example:

- The time axis uses a format to display the short month name and full year for all values.
- The number axis uses a format to prepend a `'$'` and use 2 decimal places for all values. Shorter numbers are padding with `'0'`.

The syntax used in the format strings depends on the axis type.

See the [Formatters](https://www.ag-grid.com/charts/archive/14.2.0/angular/formatters/#format-strings) page for a full list of the available formats.

## Customisation

See [Fills & Borders](https://www.ag-grid.com/charts/archive/14.2.0/angular/fills-borders/) for details on customising axis labels.


---
product: "AG Charts"
title: "Axis Labels"
description: "Use Vue chart axis labels to provide clear identification and context for the data represented on each axis in a Vue chart or Vue graph."
framework: vue
version: "14.2.0"
related:
    - title: "Axis Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-configuration/"
    - title: "Axis Types"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-types/"
    - title: "Axis Intervals"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-intervals/"
    - title: "Axis Domain"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-domain/"
    - title: "Axis Position"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-position/"
    - title: "Time Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/"
    - title: "Grid Lines & Band Shading"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-grid-lines/"
    - title: "Secondary Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-secondary/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Axis Labels

Axis labels provide clear identification and context for the data represented on each axis in a chart.

## Collision Avoidance

AG Charts has a number of methods to avoid axis label collisions, which occur when two labels overlap or when a label exceeds the axis's `maxThicknessRatio`.

#### Axis Label Collision

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="gap-right">
          <label for="avoidance-select">Avoid Collisions:</label>
          <select id="avoidance-select" v-on:change="avoidanceChange($event)">
            <option value="enabled">Enabled (default)</option>
            <option value="disabled">Disabled</option>
          </select>
        </div>
        <div>
          <label for="label-select">Labels: </label>
          <select id="label-select" v-on:change="labelChange($event)">
            <option value="year">Short</option>
            <option value="sportStar">Long</option>
          </select>
        </div>
        <button class="push-right" v-on:click="reset()">Reset</button>
      </div>
      <div class="controls-row">
        <div class="gap-right">
          <label for="truncation-select">Truncation: </label>
          <select id="truncation-select" v-on:change="truncationChange($event)">
            <option value="disabled">Disabled (default)</option>
            <option value="enabled">Enabled</option>
          </select>
        </div>
        <div class="gap-right">
          <label for="rotation-select">Rotation: </label>
          <select id="rotation-select" v-on:change="rotationChange($event)">
            <option value="auto">Auto rotation (default)</option>
            <option value="disabled">No rotation</option>
            <option value="fixed">Fixed rotation</option>
          </select>
        </div>
        <div>
          <label for="wrap-select">Wrapping: </label>
          <select id="wrap-select" v-on:change="wrapChange($event)">
            <option value="on-space">on-space (default)</option>
            <option value="always">always</option>
            <option value="hyphenate">hyphenate</option>
            <option value="never">never</option>
          </select>
        </div>
      </div>
    </div>
    <div class="resizable-container">
      <ag-charts
        :options="options"
        class="resizable"
      />
    </div>
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "year",
          yKey: "value",
        },
      ],
      axes: {
        x: {
          type: "category",
          label: {},
        },
        y: {
          type: "number",
          label: {},
        },
      },
    });

    const reset = () => {
      const optionsCopy = clone(options.value);

      const categoryAxis = optionsCopy.axes.x;
      const numberAxis = optionsCopy.axes.y;
      delete categoryAxis.label.rotation;
      delete categoryAxis.label.autoRotate;
      delete categoryAxis.label.avoidCollisions;
      delete categoryAxis.label.truncate;
      delete numberAxis.label.rotation;
      delete numberAxis.label.autoRotate;
      delete numberAxis.label.avoidCollisions;
      delete numberAxis.label.truncate;
      optionsCopy.series[0].xKey = "year";

      options.value = optionsCopy;
    };
    const rotationChange = (e) => {
      const optionsCopy = clone(options.value);

      const categoryAxis = optionsCopy.axes.x;
      const numberAxis = optionsCopy.axes.y;
      delete categoryAxis.label.rotation;
      delete numberAxis.label.rotation;
      const value = e.target.value;
      switch (value) {
        case "auto":
          categoryAxis.label.autoRotate = true;
          numberAxis.label.autoRotate = true;
          break;
        case "fixed":
          categoryAxis.label.rotation = 45;
          numberAxis.label.rotation = 45;
          categoryAxis.label.autoRotate = false;
          numberAxis.label.autoRotate = false;
          break;
        case "disabled":
          categoryAxis.label.autoRotate = false;
          numberAxis.label.autoRotate = false;
          break;
      }

      options.value = optionsCopy;
    };
    const labelChange = (e) => {
      const optionsCopy = clone(options.value);

      const value = e.target.value;
      optionsCopy.series[0].xKey = value;

      options.value = optionsCopy;
    };
    const truncationChange = (e) => {
      const optionsCopy = clone(options.value);

      const categoryAxis = optionsCopy.axes.x;
      const numberAxis = optionsCopy.axes.y;
      delete categoryAxis.label.rotation;
      delete numberAxis.label.rotation;
      const value = e.target.value;
      const enabled = value === "enabled";
      categoryAxis.label.truncate = enabled;
      numberAxis.label.truncate = enabled;

      options.value = optionsCopy;
    };
    const avoidanceChange = (e) => {
      const optionsCopy = clone(options.value);

      const categoryAxis = optionsCopy.axes.x;
      const numberAxis = optionsCopy.axes.y;
      delete categoryAxis.label.rotation;
      delete numberAxis.label.rotation;
      const value = e.target.value;
      const enabled = value === "enabled";
      categoryAxis.label.avoidCollisions = enabled;
      numberAxis.label.avoidCollisions = enabled;

      options.value = optionsCopy;
    };
    const wrapChange = (e) => {
      const optionsCopy = clone(options.value);

      const categoryAxis = optionsCopy.axes.x;
      const numberAxis = optionsCopy.axes.y;
      const value = e.target.value;
      categoryAxis.label.wrapping = value;
      numberAxis.label.wrapping = value;

      options.value = optionsCopy;
    };

    return {
      options,
      reset,
      rotationChange,
      labelChange,
      truncationChange,
      avoidanceChange,
      wrapChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Axis Label Collision](https://www.ag-grid.com/charts/archive/14.2.0/vue3/axes-labels/examples/axis-label-collision/)

In this example:

- Use the grab handle in the bottom right of the example to resize the chart. Observe how the labels behave with the different options applied.
- The first dropdown allows enabling and disabling collision avoidance altogether.
- The second dropdown buttons allows changing the length of the labels. This more easily shows the [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#wrapping) and [skipping](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#skipping) behaviour.
- The [Rotation](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#rotation), [Wrapping](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#wrapping) and [Truncation](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#truncation) controls enable exploration of their behaviour with all the available options.
- If enabled, labels try [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#wrapping), then [truncation](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#truncation), [rotation](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#rotation), and finally [skipping](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#skipping) if needed.

Collision avoidance is enabled by default, to disable set `label.avoidCollisions` to false.

```js
{
    label: {
        avoidCollisions: false,
    },
}
```

### Wrapping

Text wrapping allows labels to fit within constrained space by breaking across multiple lines.

Wrapping behaviour is set with the `label.wrapping` property:

- `'on-space'` - Wraps only on whitespace. If no suitable space is found, the next avoidance strategy is used.
- `'always'` - Forces wrapping to fit within the available space, including breaking words if needed.
- `'hyphenate'` - Similar to `'always'`, but inserts a hyphen (`-`) when wrapping in the middle of a word.
- `'never'` - Disables wrapping. Labels will remain on a single line, with the next avoidance strategy being used.

```js
{
    label: {
        wrapping: 'hyphenate',
    },
}
```

This defaults to `on-space` for Category Axes, and to `never` on all other axes types.

### Truncation

Set `truncate: true` on a label to truncate the label’s text when there isn't enough space to display it fully. This ensures as much as possible of each label remains readable without reducing the number of ticks.

When truncation occurs, hovering over the truncated text will display a tooltip with the full label text.

> **Note**
>
> Truncation takes precedence over auto-rotation. When truncation is enabled, auto-rotation will not apply.

### Rotation

Rotating axis labels allows fitting more labels into a smaller area, at the expense of readability.

Three rotation options are available:

- No rotation.
- Fixed rotation - labels are always rotated by the amount specified in the `rotation` property.
- Automatic rotation - labels are rotated if any label will be wider than the gap between ticks.

Automatic rotation can be enabled or disabled using the `autoRotate` property. It is also possible to specify a rotation angle for the automatic rotation via the `autoRotateAngle` property.

Category axes have `autoRotate` enabled by default with a default `autoRotateAngle` of `335`.

### Skipping

Label skipping is performed automatically when there is a high likelihood of collisions between labels. Labels that would collide are not displayed.

A collision is defined as labels coming within 10 pixels of each other. This minimum gap allowed between the axis labels before skipping can be configured using the `label.minSpacing` property.

```js
{
    label: {
        minSpacing: 20,
    },
}
```

If `autoRotate` is enabled, rotation will be attempted before label skipping applies.

## Alignment

Axis labels are aligned within the axis thickness and bands, with a default alignment derived from the axis position and label rotation. Both directions can be set explicitly.

### Text Alignment

Use `label.textAlign` to control the horizontal alignment of labels. This is most useful on a vertical axis containing labels of differing width.

#### Axis Label Text Alignment

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

type TextAlign = "left" | "center" | "right";

const initialXTextAlign = "center";

// 'left' is what a right-positioned vertical axis derives, so the labels start unchanged.
const initialYTextAlign = "left";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <span>X Axis:</span>
        <div class="button-group" role="group" aria-label="X Axis Text Alignment">
          <input type="radio" id="x-text-align-left" name="xTextAlign" value="left" v-on:change="setXTextAlign($event)">
            <label for="x-text-align-left"><code>left</code></label>
            <input type="radio" id="x-text-align-center" name="xTextAlign" value="center" checked="" v-on:change="setXTextAlign($event)">
              <label for="x-text-align-center"><code>center</code></label>
              <input type="radio" id="x-text-align-right" name="xTextAlign" value="right" v-on:change="setXTextAlign($event)">
                <label for="x-text-align-right"><code>right</code></label>
              </div>
              <span class="gap-left">Y Axis:</span>
              <div class="button-group" role="group" aria-label="Y Axis Text Alignment">
                <input type="radio" id="y-text-align-left" name="yTextAlign" value="left" checked="" v-on:change="setYTextAlign($event)">
                  <label for="y-text-align-left"><code>left</code></label>
                  <input type="radio" id="y-text-align-center" name="yTextAlign" value="center" v-on:change="setYTextAlign($event)">
                    <label for="y-text-align-center"><code>center</code></label>
                    <input type="radio" id="y-text-align-right" name="yTextAlign" value="right" v-on:change="setYTextAlign($event)">
                      <label for="y-text-align-right"><code>right</code></label>
                    </div>
                  </div>
                </div>
                <ag-charts
                  :options="options"
                />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "quarter",
          yKey: "revenue",
        },
      ],
      axes: {
        x: {
          type: "category",
          label: {
            textAlign: initialXTextAlign,
          },
        },
        y: {
          type: "number",
          position: "right",
          label: {
            textAlign: initialYTextAlign,
            formatter: ({ value }) => `$${value.toLocaleString()}`,
          },
        },
      },
    });

    const setXTextAlign = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.axes.x.label.textAlign = event.target.value;

      options.value = optionsCopy;
    };
    const setYTextAlign = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.axes.y.label.textAlign = event.target.value;

      options.value = optionsCopy;
    };

    return {
      options,
      setXTextAlign,
      setYTextAlign,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Axis Label Text Alignment](https://www.ag-grid.com/charts/archive/14.2.0/vue3/axes-labels/examples/axis-label-text-align/)

```js
{
    axes: {
        x: {
            label: {
                textAlign: 'center',
            },
        },
        y: {
            label: {
                textAlign: 'left',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `textAlign` options for each axis.
- On the vertical number axis, labels are horizontally aligned within the axis thickness.
- On the horizontal category axis, labels are horizontally aligned within each category band.

### Vertical Alignment

Use `label.verticalAlign` to control the vertical alignment of labels. This is most useful on a horizontal axis containing labels of differing height.

#### Axis Label Vertical Alignment

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

type VerticalAlign = "top" | "middle" | "bottom";

// The alignment each axis derives from its position, so the labels start unchanged.
const initialXVerticalAlign = "top";

const initialYVerticalAlign = "middle";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <span>X Axis:</span>
        <div class="button-group" role="group" aria-label="X Axis Vertical Alignment">
          <input type="radio" id="x-vertical-align-top" name="xVerticalAlign" value="top" checked="" v-on:change="setXVerticalAlign($event)">
            <label for="x-vertical-align-top"><code>top</code></label>
            <input type="radio" id="x-vertical-align-middle" name="xVerticalAlign" value="middle" v-on:change="setXVerticalAlign($event)">
              <label for="x-vertical-align-middle"><code>middle</code></label>
              <input type="radio" id="x-vertical-align-bottom" name="xVerticalAlign" value="bottom" v-on:change="setXVerticalAlign($event)">
                <label for="x-vertical-align-bottom"><code>bottom</code></label>
              </div>
              <span class="gap-left">Y Axis:</span>
              <div class="button-group" role="group" aria-label="Y Axis Vertical Alignment">
                <input type="radio" id="y-vertical-align-top" name="yVerticalAlign" value="top" v-on:change="setYVerticalAlign($event)">
                  <label for="y-vertical-align-top"><code>top</code></label>
                  <input type="radio" id="y-vertical-align-middle" name="yVerticalAlign" value="middle" checked="" v-on:change="setYVerticalAlign($event)">
                    <label for="y-vertical-align-middle"><code>middle</code></label>
                    <input type="radio" id="y-vertical-align-bottom" name="yVerticalAlign" value="bottom" v-on:change="setYVerticalAlign($event)">
                      <label for="y-vertical-align-bottom"><code>bottom</code></label>
                    </div>
                  </div>
                </div>
                <ag-charts
                  :options="options"
                />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "region",
          yKey: "revenue",
        },
      ],
      axes: {
        x: {
          type: "category",
          label: {
            // Region names wrap onto a differing number of lines, so alignment matters here.
            wrapping: "always",
            verticalAlign: initialXVerticalAlign,
          },
        },
        y: {
          type: "number",
          label: {
            verticalAlign: initialYVerticalAlign,
            formatter: ({ value }) => `$${value.toLocaleString()}`,
          },
        },
      },
    });

    const setXVerticalAlign = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.axes.x.label.verticalAlign = event.target.value;

      options.value = optionsCopy;
    };
    const setYVerticalAlign = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.axes.y.label.verticalAlign = event.target.value;

      options.value = optionsCopy;
    };

    return {
      options,
      setXVerticalAlign,
      setYVerticalAlign,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Axis Label Vertical Alignment](https://www.ag-grid.com/charts/archive/14.2.0/vue3/axes-labels/examples/axis-label-vertical-align/)

```js
{
    axes: {
        x: {
            label: {
                verticalAlign: 'top',
            },
        },
        y: {
            label: {
                verticalAlign: 'middle',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `verticalAlign` options for each axis.
- On the horizontal category axis, labels are vertically aligned within the axis thickness.
- On the vertical number axis, labels are vertically aligned around the tick they label.

## Label Text Formatting

The label text is taken directly from the data.

To format how this is displayed, either use a [Global Formatter](https://www.ag-grid.com/charts/archive/14.2.0/vue/formatters/), or specify an axis label level [Formatter](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#formatter) or [Format](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-labels/#format) as explained below.

> **Note**
>
> This section discusses formatting the label text. See the [Axis Intervals](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-intervals/) section to learn how to configure which labels are shown.

### Formatter

The `label.formatter` callback allows maximum flexibility for controlling what appears in the labels.

#### Axis Label Formatter

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions<DataType>>({
      data: getData(),
      title: {
        text: "Desktop Operating Systems",
      },
      series: [
        {
          type: "bar",
          xKey: "os",
          yKey: "share",
        },
      ],
      axes: {
        x: {
          type: "category",
          label: {
            formatter: ({ value }) =>
              value === "Windows" ? "== Windows ==" : value,
          },
        },
        y: {
          type: "number",
          label: {
            formatter: ({ value }) => `${value * 100}%`,
          },
        },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Axis Label Formatter](https://www.ag-grid.com/charts/archive/14.2.0/vue3/axes-labels/examples/axis-label-formatter/)

```js
{
    label: {
        formatter: function (params) {
            return params.value * 100 + '%';
        },
    },
}
```

In the above example:

- The number axis uses a formatter to multiply by 100 and append `'%'` to all values.
- The category axis uses a formatter to add `'=='` around the 'Windows' label only.

The formatter function receives a single `params` object which contains:

- The raw `value` of the label (without any default formatting applied).
- The `index` of the label in the data array.
- The number of `fractionDigits`, if the value is a number.

It is called for each label and should return a string.

### Format

The `label.format` property takes a static string representing a time or number format. This has less flexibility than the formatter, but can be serialised. For all time axes, an object format mapping a unit of time to a format string can also be used.

#### Label Format

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      series: [
        {
          type: "line",
          xKey: "date",
          yKey: "temp",
        },
      ],
      axes: {
        x: {
          type: "unit-time",
          interval: { step: "month" },
          label: {
            format: "%b %Y",
          },
        },
        y: {
          type: "number",
          label: {
            format: "$#{0>6.2f}",
          },
        },
      },
      data: [
        { date: new Date("2019-01-01"), temp: 82.0 },
        { date: new Date("2019-02-01"), temp: 75.0 },
        { date: new Date("2019-03-01"), temp: 62.0 },
        { date: new Date("2019-04-01"), temp: 99.0 },
        { date: new Date("2019-05-01"), temp: 82.0 },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Label Format](https://www.ag-grid.com/charts/archive/14.2.0/vue3/axes-labels/examples/axis-label-format/)

```js
{
    label: {
        format: '%b %Y',
    },
}
```

```js
{
    label: {
        format: '$#{0>6.2f}',
    },
}
```

In the above example:

- The time axis uses a format to display the short month name and full year for all values.
- The number axis uses a format to prepend a `'$'` and use 2 decimal places for all values. Shorter numbers are padding with `'0'`.

The syntax used in the format strings depends on the axis type.

See the [Formatters](https://www.ag-grid.com/charts/archive/14.2.0/vue/formatters/#format-strings) page for a full list of the available formats.

## Customisation

See [Fills & Borders](https://www.ag-grid.com/charts/archive/14.2.0/vue/fills-borders/) for details on customising axis labels.


---
product: "AG Charts"
title: "Axis Labels"
description: "Use React chart axis labels to provide clear identification and context for the data represented on each axis in a React chart or React graph."
framework: react
version: "14.2.0"
related:
    - title: "Axis Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-configuration/"
    - title: "Axis Types"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-types/"
    - title: "Axis Intervals"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-intervals/"
    - title: "Axis Domain"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-domain/"
    - title: "Axis Position"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-position/"
    - title: "Time Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/"
    - title: "Grid Lines & Band Shading"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-grid-lines/"
    - title: "Secondary Axes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-secondary/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Axis Labels

Axis labels provide clear identification and context for the data represented on each axis in a chart.

## Collision Avoidance

AG Charts has a number of methods to avoid axis label collisions, which occur when two labels overlap or when a label exceeds the axis's `maxThicknessRatio`.

#### Axis Label Collision

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgBarSeriesOptions,
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  AgNumberAxisOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  TextWrap,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";
import "./styles.css";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "year",
        yKey: "value",
      },
    ],
    axes: {
      x: {
        type: "category",
        label: {},
      },
      y: {
        type: "number",
        label: {},
      },
    },
  });

  const reset = () => {
    const nextOptions = clone(options);

    const categoryAxis = nextOptions.axes!.x! as AgCategoryAxisOptions;
    const numberAxis = nextOptions.axes!.y! as AgNumberAxisOptions;
    delete categoryAxis.label!.rotation;
    delete categoryAxis.label!.autoRotate;
    delete categoryAxis.label!.avoidCollisions;
    delete categoryAxis.label!.truncate;
    delete numberAxis.label!.rotation;
    delete numberAxis.label!.autoRotate;
    delete numberAxis.label!.avoidCollisions;
    delete numberAxis.label!.truncate;
    (nextOptions.series![0] as AgBarSeriesOptions).xKey = "year";

    setOptions(nextOptions);
  };

  const rotationChange = (e: Event) => {
    const nextOptions = clone(options);

    const categoryAxis = nextOptions.axes!.x! as AgCategoryAxisOptions;
    const numberAxis = nextOptions.axes!.y! as AgNumberAxisOptions;
    delete categoryAxis.label!.rotation;
    delete numberAxis.label!.rotation;
    const value = (e.target as HTMLInputElement).value;
    switch (value) {
      case "auto":
        categoryAxis.label!.autoRotate = true;
        numberAxis.label!.autoRotate = true;
        break;
      case "fixed":
        categoryAxis.label!.rotation = 45;
        numberAxis.label!.rotation = 45;
        categoryAxis.label!.autoRotate = false;
        numberAxis.label!.autoRotate = false;
        break;
      case "disabled":
        categoryAxis.label!.autoRotate = false;
        numberAxis.label!.autoRotate = false;
        break;
    }

    setOptions(nextOptions);
  };

  const labelChange = (e: Event) => {
    const nextOptions = clone(options);

    const value = (e.target as HTMLInputElement).value;
    (nextOptions.series![0] as AgBarSeriesOptions).xKey = value;

    setOptions(nextOptions);
  };

  const truncationChange = (e: Event) => {
    const nextOptions = clone(options);

    const categoryAxis = nextOptions.axes!.x! as AgCategoryAxisOptions;
    const numberAxis = nextOptions.axes!.y! as AgNumberAxisOptions;
    delete categoryAxis.label!.rotation;
    delete numberAxis.label!.rotation;
    const value = (e.target as HTMLInputElement).value;
    const enabled = value === "enabled";
    categoryAxis.label!.truncate = enabled;
    numberAxis.label!.truncate = enabled;

    setOptions(nextOptions);
  };

  const avoidanceChange = (e: Event) => {
    const nextOptions = clone(options);

    const categoryAxis = nextOptions.axes!.x! as AgCategoryAxisOptions;
    const numberAxis = nextOptions.axes!.y! as AgNumberAxisOptions;
    delete categoryAxis.label!.rotation;
    delete numberAxis.label!.rotation;
    const value = (e.target as HTMLInputElement).value;
    const enabled = value === "enabled";
    categoryAxis.label!.avoidCollisions = enabled;
    numberAxis.label!.avoidCollisions = enabled;

    setOptions(nextOptions);
  };

  const wrapChange = (e: Event) => {
    const nextOptions = clone(options);

    const categoryAxis = nextOptions.axes!.x! as AgCategoryAxisOptions;
    const numberAxis = nextOptions.axes!.y! as AgNumberAxisOptions;
    const value = (e.target as HTMLInputElement).value as TextWrap;
    categoryAxis.label!.wrapping = value;
    numberAxis.label!.wrapping = value;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div className="gap-right">
            <label htmlFor="avoidance-select">Avoid Collisions:</label>
            <select
              id="avoidance-select"
              onChange={(event) => avoidanceChange(event)}
            >
              <option value="enabled">Enabled (default)</option>
              <option value="disabled">Disabled</option>
            </select>
          </div>
          <div>
            <label htmlFor="label-select">Labels: </label>
            <select id="label-select" onChange={(event) => labelChange(event)}>
              <option value="year">Short</option>
              <option value="sportStar">Long</option>
            </select>
          </div>
          <button className="push-right" onClick={reset}>
            Reset
          </button>
        </div>
        <div className="controls-row">
          <div className="gap-right">
            <label htmlFor="truncation-select">Truncation: </label>
            <select
              id="truncation-select"
              onChange={(event) => truncationChange(event)}
            >
              <option value="disabled">Disabled (default)</option>
              <option value="enabled">Enabled</option>
            </select>
          </div>
          <div className="gap-right">
            <label htmlFor="rotation-select">Rotation: </label>
            <select
              id="rotation-select"
              onChange={(event) => rotationChange(event)}
            >
              <option value="auto">Auto rotation (default)</option>
              <option value="disabled">No rotation</option>
              <option value="fixed">Fixed rotation</option>
            </select>
          </div>
          <div>
            <label htmlFor="wrap-select">Wrapping: </label>
            <select id="wrap-select" onChange={(event) => wrapChange(event)}>
              <option value="on-space">on-space (default)</option>
              <option value="always">always</option>
              <option value="hyphenate">hyphenate</option>
              <option value="never">never</option>
            </select>
          </div>
        </div>
      </div>
      <div className="resizable-container">
        <AgCharts options={options} className="resizable" />
      </div>
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Axis Label Collision](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/axes-labels/examples/axis-label-collision/)

In this example:

- Use the grab handle in the bottom right of the example to resize the chart. Observe how the labels behave with the different options applied.
- The first dropdown allows enabling and disabling collision avoidance altogether.
- The second dropdown buttons allows changing the length of the labels. This more easily shows the [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#wrapping) and [skipping](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#skipping) behaviour.
- The [Rotation](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#rotation), [Wrapping](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#wrapping) and [Truncation](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#truncation) controls enable exploration of their behaviour with all the available options.
- If enabled, labels try [wrapping](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#wrapping), then [truncation](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#truncation), [rotation](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#rotation), and finally [skipping](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#skipping) if needed.

Collision avoidance is enabled by default, to disable set `label.avoidCollisions` to false.

```js
{
    label: {
        avoidCollisions: false,
    },
}
```

### Wrapping

Text wrapping allows labels to fit within constrained space by breaking across multiple lines.

Wrapping behaviour is set with the `label.wrapping` property:

- `'on-space'` - Wraps only on whitespace. If no suitable space is found, the next avoidance strategy is used.
- `'always'` - Forces wrapping to fit within the available space, including breaking words if needed.
- `'hyphenate'` - Similar to `'always'`, but inserts a hyphen (`-`) when wrapping in the middle of a word.
- `'never'` - Disables wrapping. Labels will remain on a single line, with the next avoidance strategy being used.

```js
{
    label: {
        wrapping: 'hyphenate',
    },
}
```

This defaults to `on-space` for Category Axes, and to `never` on all other axes types.

### Truncation

Set `truncate: true` on a label to truncate the label’s text when there isn't enough space to display it fully. This ensures as much as possible of each label remains readable without reducing the number of ticks.

When truncation occurs, hovering over the truncated text will display a tooltip with the full label text.

> **Note**
>
> Truncation takes precedence over auto-rotation. When truncation is enabled, auto-rotation will not apply.

### Rotation

Rotating axis labels allows fitting more labels into a smaller area, at the expense of readability.

Three rotation options are available:

- No rotation.
- Fixed rotation - labels are always rotated by the amount specified in the `rotation` property.
- Automatic rotation - labels are rotated if any label will be wider than the gap between ticks.

Automatic rotation can be enabled or disabled using the `autoRotate` property. It is also possible to specify a rotation angle for the automatic rotation via the `autoRotateAngle` property.

Category axes have `autoRotate` enabled by default with a default `autoRotateAngle` of `335`.

### Skipping

Label skipping is performed automatically when there is a high likelihood of collisions between labels. Labels that would collide are not displayed.

A collision is defined as labels coming within 10 pixels of each other. This minimum gap allowed between the axis labels before skipping can be configured using the `label.minSpacing` property.

```js
{
    label: {
        minSpacing: 20,
    },
}
```

If `autoRotate` is enabled, rotation will be attempted before label skipping applies.

## Alignment

Axis labels are aligned within the axis thickness and bands, with a default alignment derived from the axis position and label rotation. Both directions can be set explicitly.

### Text Alignment

Use `label.textAlign` to control the horizontal alignment of labels. This is most useful on a vertical axis containing labels of differing width.

#### Axis Label Text Alignment

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgNumberAxisOptions,
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

type TextAlign = "left" | "center" | "right";

const initialXTextAlign: TextAlign = "center";
// 'left' is what a right-positioned vertical axis derives, so the labels start unchanged.
const initialYTextAlign: TextAlign = "left";
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "quarter",
        yKey: "revenue",
      },
    ],
    axes: {
      x: {
        type: "category",
        label: {
          textAlign: initialXTextAlign,
        },
      },
      y: {
        type: "number",
        position: "right",
        label: {
          textAlign: initialYTextAlign,
          formatter: ({ value }) => `$${value.toLocaleString()}`,
        },
      } as AgNumberAxisOptions,
    },
  });

  const setXTextAlign = (event: Event) => {
    const nextOptions = clone(options);

    nextOptions.axes!.x!.label!.textAlign = (event.target as HTMLInputElement)
      .value as TextAlign;

    setOptions(nextOptions);
  };

  const setYTextAlign = (event: Event) => {
    const nextOptions = clone(options);

    nextOptions.axes!.y!.label!.textAlign = (event.target as HTMLInputElement)
      .value as TextAlign;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <span>X Axis:</span>
          <div
            className="button-group"
            role="group"
            aria-label="X Axis Text Alignment"
          >
            <input
              type="radio"
              id="x-text-align-left"
              name="xTextAlign"
              defaultValue="left"
              onChange={(event) => setXTextAlign(event)}
            />
            <label htmlFor="x-text-align-left">
              <code>left</code>
            </label>
            <input
              type="radio"
              id="x-text-align-center"
              name="xTextAlign"
              defaultValue="center"
              defaultChecked
              onChange={(event) => setXTextAlign(event)}
            />
            <label htmlFor="x-text-align-center">
              <code>center</code>
            </label>
            <input
              type="radio"
              id="x-text-align-right"
              name="xTextAlign"
              defaultValue="right"
              onChange={(event) => setXTextAlign(event)}
            />
            <label htmlFor="x-text-align-right">
              <code>right</code>
            </label>
          </div>
          <span className="gap-left">Y Axis:</span>
          <div
            className="button-group"
            role="group"
            aria-label="Y Axis Text Alignment"
          >
            <input
              type="radio"
              id="y-text-align-left"
              name="yTextAlign"
              defaultValue="left"
              defaultChecked
              onChange={(event) => setYTextAlign(event)}
            />
            <label htmlFor="y-text-align-left">
              <code>left</code>
            </label>
            <input
              type="radio"
              id="y-text-align-center"
              name="yTextAlign"
              defaultValue="center"
              onChange={(event) => setYTextAlign(event)}
            />
            <label htmlFor="y-text-align-center">
              <code>center</code>
            </label>
            <input
              type="radio"
              id="y-text-align-right"
              name="yTextAlign"
              defaultValue="right"
              onChange={(event) => setYTextAlign(event)}
            />
            <label htmlFor="y-text-align-right">
              <code>right</code>
            </label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Axis Label Text Alignment](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/axes-labels/examples/axis-label-text-align/)

```js
{
    axes: {
        x: {
            label: {
                textAlign: 'center',
            },
        },
        y: {
            label: {
                textAlign: 'left',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `textAlign` options for each axis.
- On the vertical number axis, labels are horizontally aligned within the axis thickness.
- On the horizontal category axis, labels are horizontally aligned within each category band.

### Vertical Alignment

Use `label.verticalAlign` to control the vertical alignment of labels. This is most useful on a horizontal axis containing labels of differing height.

#### Axis Label Vertical Alignment

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

type VerticalAlign = "top" | "middle" | "bottom";

// The alignment each axis derives from its position, so the labels start unchanged.
const initialXVerticalAlign: VerticalAlign = "top";
const initialYVerticalAlign: VerticalAlign = "middle";
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "region",
        yKey: "revenue",
      },
    ],
    axes: {
      x: {
        type: "category",
        label: {
          // Region names wrap onto a differing number of lines, so alignment matters here.
          wrapping: "always",
          verticalAlign: initialXVerticalAlign,
        },
      } as AgCategoryAxisOptions,
      y: {
        type: "number",
        label: {
          verticalAlign: initialYVerticalAlign,
          formatter: ({ value }) => `$${value.toLocaleString()}`,
        },
      },
    },
  });

  const setXVerticalAlign = (event: Event) => {
    const nextOptions = clone(options);

    nextOptions.axes!.x!.label!.verticalAlign = (
      event.target as HTMLInputElement
    ).value as VerticalAlign;

    setOptions(nextOptions);
  };

  const setYVerticalAlign = (event: Event) => {
    const nextOptions = clone(options);

    nextOptions.axes!.y!.label!.verticalAlign = (
      event.target as HTMLInputElement
    ).value as VerticalAlign;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <span>X Axis:</span>
          <div
            className="button-group"
            role="group"
            aria-label="X Axis Vertical Alignment"
          >
            <input
              type="radio"
              id="x-vertical-align-top"
              name="xVerticalAlign"
              defaultValue="top"
              defaultChecked
              onChange={(event) => setXVerticalAlign(event)}
            />
            <label htmlFor="x-vertical-align-top">
              <code>top</code>
            </label>
            <input
              type="radio"
              id="x-vertical-align-middle"
              name="xVerticalAlign"
              defaultValue="middle"
              onChange={(event) => setXVerticalAlign(event)}
            />
            <label htmlFor="x-vertical-align-middle">
              <code>middle</code>
            </label>
            <input
              type="radio"
              id="x-vertical-align-bottom"
              name="xVerticalAlign"
              defaultValue="bottom"
              onChange={(event) => setXVerticalAlign(event)}
            />
            <label htmlFor="x-vertical-align-bottom">
              <code>bottom</code>
            </label>
          </div>
          <span className="gap-left">Y Axis:</span>
          <div
            className="button-group"
            role="group"
            aria-label="Y Axis Vertical Alignment"
          >
            <input
              type="radio"
              id="y-vertical-align-top"
              name="yVerticalAlign"
              defaultValue="top"
              onChange={(event) => setYVerticalAlign(event)}
            />
            <label htmlFor="y-vertical-align-top">
              <code>top</code>
            </label>
            <input
              type="radio"
              id="y-vertical-align-middle"
              name="yVerticalAlign"
              defaultValue="middle"
              defaultChecked
              onChange={(event) => setYVerticalAlign(event)}
            />
            <label htmlFor="y-vertical-align-middle">
              <code>middle</code>
            </label>
            <input
              type="radio"
              id="y-vertical-align-bottom"
              name="yVerticalAlign"
              defaultValue="bottom"
              onChange={(event) => setYVerticalAlign(event)}
            />
            <label htmlFor="y-vertical-align-bottom">
              <code>bottom</code>
            </label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Axis Label Vertical Alignment](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/axes-labels/examples/axis-label-vertical-align/)

```js
{
    axes: {
        x: {
            label: {
                verticalAlign: 'top',
            },
        },
        y: {
            label: {
                verticalAlign: 'middle',
            },
        },
    },
}
```

In this example:

- Use the buttons to see the `verticalAlign` options for each axis.
- On the horizontal category axis, labels are vertically aligned within the axis thickness.
- On the vertical number axis, labels are vertically aligned around the tick they label.

## Label Text Formatting

The label text is taken directly from the data.

To format how this is displayed, either use a [Global Formatter](https://www.ag-grid.com/charts/archive/14.2.0/react/formatters/), or specify an axis label level [Formatter](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#formatter) or [Format](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-labels/#format) as explained below.

> **Note**
>
> This section discusses formatting the label text. See the [Axis Intervals](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-intervals/) section to learn how to configure which labels are shown.

### Formatter

The `label.formatter` callback allows maximum flexibility for controlling what appears in the labels.

#### Axis Label Formatter

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions<DataType>>({
    data: getData(),
    title: {
      text: "Desktop Operating Systems",
    },
    series: [
      {
        type: "bar",
        xKey: "os",
        yKey: "share",
      },
    ],
    axes: {
      x: {
        type: "category",
        label: {
          formatter: ({ value }) =>
            value === "Windows" ? "== Windows ==" : value,
        },
      },
      y: {
        type: "number",
        label: {
          formatter: ({ value }) => `${value * 100}%`,
        },
      },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Axis Label Formatter](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/axes-labels/examples/axis-label-formatter/)

```js
{
    label: {
        formatter: function (params) {
            return params.value * 100 + '%';
        },
    },
}
```

In the above example:

- The number axis uses a formatter to multiply by 100 and append `'%'` to all values.
- The category axis uses a formatter to add `'=='` around the 'Windows' label only.

The formatter function receives a single `params` object which contains:

- The raw `value` of the label (without any default formatting applied).
- The `index` of the label in the data array.
- The number of `fractionDigits`, if the value is a number.

It is called for each label and should return a string.

### Format

The `label.format` property takes a static string representing a time or number format. This has less flexibility than the formatter, but can be serialised. For all time axes, an object format mapping a unit of time to a format string can also be used.

#### Label Format

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    series: [
      {
        type: "line",
        xKey: "date",
        yKey: "temp",
      },
    ],
    axes: {
      x: {
        type: "unit-time",
        interval: { step: "month" },
        label: {
          format: "%b %Y",
        },
      },
      y: {
        type: "number",
        label: {
          format: "$#{0>6.2f}",
        },
      },
    },
    data: [
      { date: new Date("2019-01-01"), temp: 82.0 },
      { date: new Date("2019-02-01"), temp: 75.0 },
      { date: new Date("2019-03-01"), temp: 62.0 },
      { date: new Date("2019-04-01"), temp: 99.0 },
      { date: new Date("2019-05-01"), temp: 82.0 },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Label Format](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/axes-labels/examples/axis-label-format/)

```js
{
    label: {
        format: '%b %Y',
    },
}
```

```js
{
    label: {
        format: '$#{0>6.2f}',
    },
}
```

In the above example:

- The time axis uses a format to display the short month name and full year for all values.
- The number axis uses a format to prepend a `'$'` and use 2 decimal places for all values. Shorter numbers are padding with `'0'`.

The syntax used in the format strings depends on the axis type.

See the [Formatters](https://www.ag-grid.com/charts/archive/14.2.0/react/formatters/#format-strings) page for a full list of the available formats.

## Customisation

See [Fills & Borders](https://www.ag-grid.com/charts/archive/14.2.0/react/fills-borders/) for details on customising axis labels.
